<template>
  <div class="count-to-wrapper">
    <slot name="left"/>
    <p class="content-outer"><span :class="['count-to-count-text', countClass]" :id="counterId">{{ init }}</span><i :class="['count-to-unit-text', unitClass]">{{ unitText }}</i></p>
    <slot name="right"/>
  </div>
</template>

<script>
import CountUp from 'countup'
import './index.less'
export default {
  name: 'CountTo',
  props: {
    init: {
      type: Number,
      default: 0
    },
    /**
     * @description Начальное значение, т.e значение, отображаемое до начала анимации
     */
    startVal: {
      type: Number,
      default: 0
    },
    /**
     * @description Конечное значение, т.е значение, отображаемое после окончания анимации
     */
    end: {
      type: Number,
      required: true
    },
    /**
     * @description Оставить несколько десятичных знаков
     */
    decimals: {
      type: Number,
      default: 0
    },
    /**
     * @description
     */
    decimal: {
      type: String,
      default: '.'
    },
    /**
     * @description Продолжительность анимации в секундах
     */
    duration: {
      type: Number,
      default: 2
    },
    /**
     * @description Время, когда начинается задержка анимации, в секундах
     */
    delay: {
      type: Number,
      default: 0
    },
    /**
     * @description
     */
    uneasing: {
      type: Boolean,
      default: false
    },
    /**
     * @description Независимо от того, следует ли использовать группировку, каждые три цифры будут разделены символом после группировки
     */
    usegroup: {
      type: Boolean,
      default: false
    },
    /**
     * @description Символы, используемые для группировки (usegroup)
     */
    separator: {
      type: String,
      default: ','
    },
    /**
     * @description
     */
    simplify: {
      type: Boolean,
      default: false
    },
    /**
     * @description Пользовательские единицы измерения, такие как [3, 'K+'], [6, 'M+'], т.е, если число больше 3 цифр, а число меньше 6 цифр, используйте для этого k+. Опустить 1000, и оно будет отображаться как 1K+.
     */
    unit: {
      type: Array,
      default () {
        return [[3, 'K+'], [6, 'M+'], [9, 'B+']]
      }
    },
    countClass: {
      type: String,
      default: ''
    },
    unitClass: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      counter: null,
      unitText: ''
    }
  },
  computed: {
    counterId () {
      return `count_to_${this._uid}`
    }
  },
  methods: {
    getHandleVal (val, len) {
      return {
        endVal: parseInt(val / Math.pow(10, this.unit[len - 1][0])),
        unitText: this.unit[len - 1][1]
      }
    },
    transformValue (val) {
      let len = this.unit.length
      let res = {
        endVal: 0,
        unitText: ''
      }
      if (val < Math.pow(10, this.unit[0][0])) res.endVal = val
      else {
        for (let i = 1; i < len; i++) {
          if (val >= Math.pow(10, this.unit[i - 1][0]) && val < Math.pow(10, this.unit[i][0])) res = this.getHandleVal(val, i)
        }
      }
      if (val > Math.pow(10, this.unit[len - 1][0])) res = this.getHandleVal(val, len)
      return res
    },
    getValue (val) {
      let res = 0
      if (this.simplify) {
        let { endVal, unitText } = this.transformValue(val)
        this.unitText = unitText
        res = endVal
      } else {
        res = val
      }
      return res
    }
  },
  mounted () {
    this.$nextTick(() => {
      let endVal = this.getValue(this.end)
      this.counter = new CountUp(this.counterId, this.startVal, endVal, this.decimals, this.duration, {
        useEasing: !this.uneasing,
        useGrouping: this.useGroup,
        separator: this.separator,
        decimal: this.decimal
      })
      setTimeout(() => {
        if (!this.counter.error) this.counter.start()
      }, this.delay)
    })
  },
  watch: {
    end (newVal) {
      let endVal = this.getValue(newVal)
      this.counter.update(endVal)
    }
  }
}
</script>
